import numpy as np

def foo(x,y,z,a=1,b=2,c=0):
    r2 = x**2+y**2+z**2
    r = np.sqrt(r2)
    div_r3 = 1.0/r**3
    div_r5 = 1.0/r**5
    f = a*r2 + b*r + c
    df = 2.0*a*x + b*x/r, 2.0*a*y + b*y/r, 2.0*a*z + b*z/r 
    d2f = 2.0*a + b*(r2-x**2)*div_r3, 2.0*a + b*(r2-y**2)*div_r3, 2.0*a + b*(r2-z**2)*div_r3
    d3f = -6*x*(y**2+z**2)*div_r5,-6*y*(x**2+z**2)*div_r5,-6*z*(x**2+y**2)*div_r5 
    return f, df, d2f, d3f 

dxyz = 0.1, 0.2, 0.4 # do convergence
dx, dy, dz = dxyz
Lh = 5.0

xyz = []
for d in range(0,3):
    xyz.append(np.arange(-Lh+dxyz[d]/2,Lh,dxyz[d]))

x,y,z = np.meshgrid(xyz[0],xyz[1],xyz[2],
                    indexing="ij")

f,df,d2f,d3f = foo(x,y,z)
#df_= np.gradient(f,x1,y1,z1, edge_order = 2)
df_ = np.gradient(f,dx,dy,dz, edge_order = 2)

for d in range(0,3):
    print('df{} Finite? {}  '.format(d,np.isfinite(df_[d]).all()))

 
amax = []
for d in range(0,3):
    maxfderr = np.max(np.abs(dxyz[d]**2 *d3f[d]/3.0))
    aclose = np.allclose(df[d],df_[d],rtol=0,atol=1.01*maxfderr)
    amax.append(np.max(np.abs(df_[d] - df[d])))
    print('Close? {} max_diff = {:.2e}  max_df_err = {:.2e}'.format(aclose,amax[d],maxfderr))
